# EKKINISH (Edo theoritika den allazoyme kamia grammi kodika)
from __future__ import division
from visual import *
from physutil import *
import csv


# Kodikas gia tin grafiki anaparastasi toy montelou
# ===========================================

# Arxikopoiisi parathirou gia anaparastasi
scene.autoscale = 0
scene.height = 600
scene.width = 600
scene.range = vector(2.0,2.0,2.0)
# Dimiourgia antikeimenou gia montelopoiisi
support = cylinder( pos = (0, 0, -0.5), axis = (0,0,1), radius = 0.02)

# To "frame" omadopoiei ena i perissotera antikeimena
pendulum = frame()
# To "frame" apoteleitai apo enan kylindro kai mia sfaira
# kai ayto einai to ekkremes
cylinder(frame=pendulum, pos=(0,0,0), radius=0.01, length=1, color=color.cyan)
sphere(frame=pendulum, pos=(1,0,0), radius=0.1, color=color.red)



# IDIOTITES SYSTHMATOS KAI ARXIKES PROYPOTHESEIS
# ===========================================

# H arxiki gonia se rad (Mporeite na tin allajete)
theta = pi/8.0

# H arxiki goniaki taxytita
omega = 0

# H epitaxynsi tis barititas kai to mikos toy ekkremous
g = 9.80
L = 1.00


# Thesi toy ekkremous
pendulum.pos = (0,0,0)

# Peristrofi tou ekkremoys gyro apo ton ajona z. To programma VPython
# metraei tin gonia me basi ton ajona x. Emeis metrame tin gonia me
# basi ton ajona -y. Gia ton logo ayto afairoume pi/2 rad.
pendulum.rotate(axis = (0,0,1), angle = theta - pi/2.0)

t = 0. # o xronos enarjis tou peiramatos

# Stin epomeni metabliti apothikeyoyme tin palia timi xronoy
# Arxika dinoume gia ayti tin metabliti tin adinati timi -1
t_old = -1.

# Bima xronou dt
# Tin parakato grammi mporeite na tin allajete
dt = 0.0005

# H timi "1" einai panta sosti, ara i epomeni epanalipsi
# synexizetai ep' apeiron

while 1:

    # Sixnotita tis kinisis (fps)
    rate(1/dt)

    # Goniaki epitaxynsi
    alpha = -(g/L) * sin(theta)

    # H nea timi tis goniakis taxytitas
    omega = omega + alpha * dt

    # H metaboli tis gonias toy ekkremous
    d_theta = omega * dt

    # Prosdiorismos tis periodou toy ekkremoys
    # Otan to ekkremes kineitai apo deksia pros ta aristera
    if(theta > 0 and theta + d_theta < 0) :
        # Ean to ekkremes exei idi ektelesei mia talantosi       
        if(t_old > 0):
            print "     =", t - t_old, "sec"
        # Apothikeysi toy xronoy stin metabliti t_old
        t_old = t

    # Peristrofi toy ekkremoys me metaboli tis gonias
    pendulum.rotate(axis = (0,0,1), angle = d_theta)

    # H nea timi tis gonias
    theta = theta + d_theta

    # H nea timi toy xronoy
    t = t + dt
